diff --git a/src/backend/snowball/libstemmer/stem_ISO_8859_1_italian.c b/src/backend/snowball/libstemmer/stem_ISO_8859_1_italian.c
index d941b0f036..fca2e3af1c 100644
--- a/src/backend/snowball/libstemmer/stem_ISO_8859_1_italian.c
+++ b/src/backend/snowball/libstemmer/stem_ISO_8859_1_italian.c
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #include "header.h"
 
@@ -476,34 +476,29 @@ static const symbol s_2[] = { 0xEC };
 static const symbol s_3[] = { 0xF2 };
 static const symbol s_4[] = { 0xF9 };
 static const symbol s_5[] = { 'q', 'U' };
-static const symbol s_6[] = { 'u' };
-static const symbol s_7[] = { 'U' };
+static const symbol s_6[] = { 'U' };
+static const symbol s_7[] = { 'I' };
 static const symbol s_8[] = { 'i' };
-static const symbol s_9[] = { 'I' };
-static const symbol s_10[] = { 'i' };
-static const symbol s_11[] = { 'u' };
-static const symbol s_12[] = { 'e' };
-static const symbol s_13[] = { 'i', 'c' };
-static const symbol s_14[] = { 'l', 'o', 'g' };
-static const symbol s_15[] = { 'u' };
-static const symbol s_16[] = { 'e', 'n', 't', 'e' };
-static const symbol s_17[] = { 'a', 't' };
-static const symbol s_18[] = { 'a', 't' };
-static const symbol s_19[] = { 'i', 'c' };
-static const symbol s_20[] = { 'i' };
-static const symbol s_21[] = { 'h' };
+static const symbol s_9[] = { 'u' };
+static const symbol s_10[] = { 'e' };
+static const symbol s_11[] = { 'i', 'c' };
+static const symbol s_12[] = { 'l', 'o', 'g' };
+static const symbol s_13[] = { 'u' };
+static const symbol s_14[] = { 'e', 'n', 't', 'e' };
+static const symbol s_15[] = { 'a', 't' };
+static const symbol s_16[] = { 'a', 't' };
+static const symbol s_17[] = { 'i', 'c' };
 
-static int r_prelude(struct SN_env * z) {
+static int r_prelude(struct SN_env * z) { /* forwardmode */
     int among_var;
-    {   int c_test = z->c; /* test, line 35 */
+    {   int c_test1 = z->c; /* test, line 35 */
         while(1) { /* repeat, line 35 */
-            int c1 = z->c;
+            int c2 = z->c;
             z->bra = z->c; /* [, line 36 */
             among_var = find_among(z, a_0, 7); /* substring, line 36 */
             if (!(among_var)) goto lab0;
             z->ket = z->c; /* ], line 36 */
-            switch(among_var) {
-                case 0: goto lab0;
+            switch (among_var) { /* among, line 36 */
                 case 1:
                     {   int ret = slice_from_s(z, 1, s_0); /* <-, line 37 */
                         if (ret < 0) return ret;
@@ -541,59 +536,61 @@ static int r_prelude(struct SN_env * z) {
             }
             continue;
         lab0:
-            z->c = c1;
+            z->c = c2;
             break;
         }
-        z->c = c_test;
+        z->c = c_test1;
     }
     while(1) { /* repeat, line 46 */
-        int c2 = z->c;
+        int c3 = z->c;
         while(1) { /* goto, line 46 */
-            int c3 = z->c;
-            if (in_grouping(z, g_v, 97, 249, 0)) goto lab2;
+            int c4 = z->c;
+            if (in_grouping(z, g_v, 97, 249, 0)) goto lab2; /* grouping v, line 47 */
             z->bra = z->c; /* [, line 47 */
-            {   int c4 = z->c; /* or, line 47 */
-                if (!(eq_s(z, 1, s_6))) goto lab4;
+            {   int c5 = z->c; /* or, line 47 */
+                if (z->c == z->l || z->p[z->c] != 'u') goto lab4; /* literal, line 47 */
+                z->c++;
                 z->ket = z->c; /* ], line 47 */
-                if (in_grouping(z, g_v, 97, 249, 0)) goto lab4;
-                {   int ret = slice_from_s(z, 1, s_7); /* <-, line 47 */
+                if (in_grouping(z, g_v, 97, 249, 0)) goto lab4; /* grouping v, line 47 */
+                {   int ret = slice_from_s(z, 1, s_6); /* <-, line 47 */
                     if (ret < 0) return ret;
                 }
                 goto lab3;
             lab4:
-                z->c = c4;
-                if (!(eq_s(z, 1, s_8))) goto lab2;
+                z->c = c5;
+                if (z->c == z->l || z->p[z->c] != 'i') goto lab2; /* literal, line 48 */
+                z->c++;
                 z->ket = z->c; /* ], line 48 */
-                if (in_grouping(z, g_v, 97, 249, 0)) goto lab2;
-                {   int ret = slice_from_s(z, 1, s_9); /* <-, line 48 */
+                if (in_grouping(z, g_v, 97, 249, 0)) goto lab2; /* grouping v, line 48 */
+                {   int ret = slice_from_s(z, 1, s_7); /* <-, line 48 */
                     if (ret < 0) return ret;
                 }
             }
         lab3:
-            z->c = c3;
+            z->c = c4;
             break;
         lab2:
-            z->c = c3;
+            z->c = c4;
             if (z->c >= z->l) goto lab1;
             z->c++; /* goto, line 46 */
         }
         continue;
     lab1:
-        z->c = c2;
+        z->c = c3;
         break;
     }
     return 1;
 }
 
-static int r_mark_regions(struct SN_env * z) {
-    z->I[0] = z->l;
-    z->I[1] = z->l;
-    z->I[2] = z->l;
+static int r_mark_regions(struct SN_env * z) { /* forwardmode */
+    z->I[0] = z->l; /* $pV = <integer expression>, line 54 */
+    z->I[1] = z->l; /* $p1 = <integer expression>, line 55 */
+    z->I[2] = z->l; /* $p2 = <integer expression>, line 56 */
     {   int c1 = z->c; /* do, line 58 */
         {   int c2 = z->c; /* or, line 60 */
-            if (in_grouping(z, g_v, 97, 249, 0)) goto lab2;
+            if (in_grouping(z, g_v, 97, 249, 0)) goto lab2; /* grouping v, line 59 */
             {   int c3 = z->c; /* or, line 59 */
-                if (out_grouping(z, g_v, 97, 249, 0)) goto lab4;
+                if (out_grouping(z, g_v, 97, 249, 0)) goto lab4; /* non v, line 59 */
                 {    /* gopast */ /* grouping v, line 59 */
                     int ret = out_grouping(z, g_v, 97, 249, 1);
                     if (ret < 0) goto lab4;
@@ -602,7 +599,7 @@ static int r_mark_regions(struct SN_env * z) {
                 goto lab3;
             lab4:
                 z->c = c3;
-                if (in_grouping(z, g_v, 97, 249, 0)) goto lab2;
+                if (in_grouping(z, g_v, 97, 249, 0)) goto lab2; /* grouping v, line 59 */
                 {    /* gopast */ /* non v, line 59 */
                     int ret = in_grouping(z, g_v, 97, 249, 1);
                     if (ret < 0) goto lab2;
@@ -613,9 +610,9 @@ static int r_mark_regions(struct SN_env * z) {
             goto lab1;
         lab2:
             z->c = c2;
-            if (out_grouping(z, g_v, 97, 249, 0)) goto lab0;
+            if (out_grouping(z, g_v, 97, 249, 0)) goto lab0; /* non v, line 61 */
             {   int c4 = z->c; /* or, line 61 */
-                if (out_grouping(z, g_v, 97, 249, 0)) goto lab6;
+                if (out_grouping(z, g_v, 97, 249, 0)) goto lab6; /* non v, line 61 */
                 {    /* gopast */ /* grouping v, line 61 */
                     int ret = out_grouping(z, g_v, 97, 249, 1);
                     if (ret < 0) goto lab6;
@@ -624,7 +621,7 @@ static int r_mark_regions(struct SN_env * z) {
                 goto lab5;
             lab6:
                 z->c = c4;
-                if (in_grouping(z, g_v, 97, 249, 0)) goto lab0;
+                if (in_grouping(z, g_v, 97, 249, 0)) goto lab0; /* grouping v, line 61 */
                 if (z->c >= z->l) goto lab0;
                 z->c++; /* next, line 61 */
             }
@@ -665,24 +662,23 @@ static int r_mark_regions(struct SN_env * z) {
     return 1;
 }
 
-static int r_postlude(struct SN_env * z) {
+static int r_postlude(struct SN_env * z) { /* forwardmode */
     int among_var;
     while(1) { /* repeat, line 70 */
         int c1 = z->c;
         z->bra = z->c; /* [, line 72 */
-        if (z->c >= z->l || (z->p[z->c + 0] != 73 && z->p[z->c + 0] != 85)) among_var = 3; else
-        among_var = find_among(z, a_1, 3); /* substring, line 72 */
+        if (z->c >= z->l || (z->p[z->c + 0] != 73 && z->p[z->c + 0] != 85)) among_var = 3; else /* substring, line 72 */
+        among_var = find_among(z, a_1, 3);
         if (!(among_var)) goto lab0;
         z->ket = z->c; /* ], line 72 */
-        switch(among_var) {
-            case 0: goto lab0;
+        switch (among_var) { /* among, line 72 */
             case 1:
-                {   int ret = slice_from_s(z, 1, s_10); /* <-, line 73 */
+                {   int ret = slice_from_s(z, 1, s_8); /* <-, line 73 */
                     if (ret < 0) return ret;
                 }
                 break;
             case 2:
-                {   int ret = slice_from_s(z, 1, s_11); /* <-, line 74 */
+                {   int ret = slice_from_s(z, 1, s_9); /* <-, line 74 */
                     if (ret < 0) return ret;
                 }
                 break;
@@ -699,43 +695,41 @@ static int r_postlude(struct SN_env * z) {
     return 1;
 }
 
-static int r_RV(struct SN_env * z) {
-    if (!(z->I[0] <= z->c)) return 0;
+static int r_RV(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[0] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 82 */
     return 1;
 }
 
-static int r_R1(struct SN_env * z) {
-    if (!(z->I[1] <= z->c)) return 0;
+static int r_R1(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[1] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 83 */
     return 1;
 }
 
-static int r_R2(struct SN_env * z) {
-    if (!(z->I[2] <= z->c)) return 0;
+static int r_R2(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[2] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 84 */
     return 1;
 }
 
-static int r_attached_pronoun(struct SN_env * z) {
+static int r_attached_pronoun(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 87 */
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((33314 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    if (!(find_among_b(z, a_2, 37))) return 0; /* substring, line 87 */
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((33314 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 87 */
+    if (!(find_among_b(z, a_2, 37))) return 0;
     z->bra = z->c; /* ], line 87 */
-    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 111 && z->p[z->c - 1] != 114)) return 0;
-    among_var = find_among_b(z, a_3, 5); /* among, line 97 */
+    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 111 && z->p[z->c - 1] != 114)) return 0; /* among, line 97 */
+    among_var = find_among_b(z, a_3, 5);
     if (!(among_var)) return 0;
-    {   int ret = r_RV(z);
-        if (ret == 0) return 0; /* call RV, line 97 */
-        if (ret < 0) return ret;
+    {   int ret = r_RV(z); /* call RV, line 97 */
+        if (ret <= 0) return ret;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 97 */
         case 1:
             {   int ret = slice_del(z); /* delete, line 98 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = slice_from_s(z, 1, s_12); /* <-, line 99 */
+            {   int ret = slice_from_s(z, 1, s_10); /* <-, line 99 */
                 if (ret < 0) return ret;
             }
             break;
@@ -743,37 +737,34 @@ static int r_attached_pronoun(struct SN_env * z) {
     return 1;
 }
 
-static int r_standard_suffix(struct SN_env * z) {
+static int r_standard_suffix(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 104 */
     among_var = find_among_b(z, a_6, 51); /* substring, line 104 */
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 104 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 104 */
         case 1:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 111 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 111 */
+                if (ret <= 0) return ret;
             }
             {   int ret = slice_del(z); /* delete, line 111 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 113 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 113 */
+                if (ret <= 0) return ret;
             }
             {   int ret = slice_del(z); /* delete, line 113 */
                 if (ret < 0) return ret;
             }
-            {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 114 */
+            {   int m1 = z->l - z->c; (void)m1; /* try, line 114 */
                 z->ket = z->c; /* [, line 114 */
-                if (!(eq_s_b(z, 2, s_13))) { z->c = z->l - m_keep; goto lab0; }
+                if (!(eq_s_b(z, 2, s_11))) { z->c = z->l - m1; goto lab0; } /* literal, line 114 */
                 z->bra = z->c; /* ], line 114 */
-                {   int ret = r_R2(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab0; } /* call R2, line 114 */
+                {   int ret = r_R2(z); /* call R2, line 114 */
+                    if (ret == 0) { z->c = z->l - m1; goto lab0; }
                     if (ret < 0) return ret;
                 }
                 {   int ret = slice_del(z); /* delete, line 114 */
@@ -784,70 +775,64 @@ static int r_standard_suffix(struct SN_env * z) {
             }
             break;
         case 3:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 117 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 117 */
+                if (ret <= 0) return ret;
             }
-            {   int ret = slice_from_s(z, 3, s_14); /* <-, line 117 */
+            {   int ret = slice_from_s(z, 3, s_12); /* <-, line 117 */
                 if (ret < 0) return ret;
             }
             break;
         case 4:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 119 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 119 */
+                if (ret <= 0) return ret;
             }
-            {   int ret = slice_from_s(z, 1, s_15); /* <-, line 119 */
+            {   int ret = slice_from_s(z, 1, s_13); /* <-, line 119 */
                 if (ret < 0) return ret;
             }
             break;
         case 5:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 121 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 121 */
+                if (ret <= 0) return ret;
             }
-            {   int ret = slice_from_s(z, 4, s_16); /* <-, line 121 */
+            {   int ret = slice_from_s(z, 4, s_14); /* <-, line 121 */
                 if (ret < 0) return ret;
             }
             break;
         case 6:
-            {   int ret = r_RV(z);
-                if (ret == 0) return 0; /* call RV, line 123 */
-                if (ret < 0) return ret;
+            {   int ret = r_RV(z); /* call RV, line 123 */
+                if (ret <= 0) return ret;
             }
             {   int ret = slice_del(z); /* delete, line 123 */
                 if (ret < 0) return ret;
             }
             break;
         case 7:
-            {   int ret = r_R1(z);
-                if (ret == 0) return 0; /* call R1, line 125 */
-                if (ret < 0) return ret;
+            {   int ret = r_R1(z); /* call R1, line 125 */
+                if (ret <= 0) return ret;
             }
             {   int ret = slice_del(z); /* delete, line 125 */
                 if (ret < 0) return ret;
             }
-            {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 126 */
+            {   int m2 = z->l - z->c; (void)m2; /* try, line 126 */
                 z->ket = z->c; /* [, line 127 */
-                if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((4722696 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->c = z->l - m_keep; goto lab1; }
-                among_var = find_among_b(z, a_4, 4); /* substring, line 127 */
-                if (!(among_var)) { z->c = z->l - m_keep; goto lab1; }
+                if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((4722696 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->c = z->l - m2; goto lab1; } /* substring, line 127 */
+                among_var = find_among_b(z, a_4, 4);
+                if (!(among_var)) { z->c = z->l - m2; goto lab1; }
                 z->bra = z->c; /* ], line 127 */
-                {   int ret = r_R2(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab1; } /* call R2, line 127 */
+                {   int ret = r_R2(z); /* call R2, line 127 */
+                    if (ret == 0) { z->c = z->l - m2; goto lab1; }
                     if (ret < 0) return ret;
                 }
                 {   int ret = slice_del(z); /* delete, line 127 */
                     if (ret < 0) return ret;
                 }
-                switch(among_var) {
-                    case 0: { z->c = z->l - m_keep; goto lab1; }
+                switch (among_var) { /* among, line 127 */
                     case 1:
                         z->ket = z->c; /* [, line 128 */
-                        if (!(eq_s_b(z, 2, s_17))) { z->c = z->l - m_keep; goto lab1; }
+                        if (!(eq_s_b(z, 2, s_15))) { z->c = z->l - m2; goto lab1; } /* literal, line 128 */
                         z->bra = z->c; /* ], line 128 */
-                        {   int ret = r_R2(z);
-                            if (ret == 0) { z->c = z->l - m_keep; goto lab1; } /* call R2, line 128 */
+                        {   int ret = r_R2(z); /* call R2, line 128 */
+                            if (ret == 0) { z->c = z->l - m2; goto lab1; }
                             if (ret < 0) return ret;
                         }
                         {   int ret = slice_del(z); /* delete, line 128 */
@@ -860,59 +845,51 @@ static int r_standard_suffix(struct SN_env * z) {
             }
             break;
         case 8:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 134 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 134 */
+                if (ret <= 0) return ret;
             }
             {   int ret = slice_del(z); /* delete, line 134 */
                 if (ret < 0) return ret;
             }
-            {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 135 */
+            {   int m3 = z->l - z->c; (void)m3; /* try, line 135 */
                 z->ket = z->c; /* [, line 136 */
-                if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((4198408 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->c = z->l - m_keep; goto lab2; }
-                among_var = find_among_b(z, a_5, 3); /* substring, line 136 */
-                if (!(among_var)) { z->c = z->l - m_keep; goto lab2; }
+                if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((4198408 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->c = z->l - m3; goto lab2; } /* substring, line 136 */
+                if (!(find_among_b(z, a_5, 3))) { z->c = z->l - m3; goto lab2; }
                 z->bra = z->c; /* ], line 136 */
-                switch(among_var) {
-                    case 0: { z->c = z->l - m_keep; goto lab2; }
-                    case 1:
-                        {   int ret = r_R2(z);
-                            if (ret == 0) { z->c = z->l - m_keep; goto lab2; } /* call R2, line 137 */
-                            if (ret < 0) return ret;
-                        }
-                        {   int ret = slice_del(z); /* delete, line 137 */
-                            if (ret < 0) return ret;
-                        }
-                        break;
+                {   int ret = r_R2(z); /* call R2, line 137 */
+                    if (ret == 0) { z->c = z->l - m3; goto lab2; }
+                    if (ret < 0) return ret;
+                }
+                {   int ret = slice_del(z); /* delete, line 137 */
+                    if (ret < 0) return ret;
                 }
             lab2:
                 ;
             }
             break;
         case 9:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 142 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 142 */
+                if (ret <= 0) return ret;
             }
             {   int ret = slice_del(z); /* delete, line 142 */
                 if (ret < 0) return ret;
             }
-            {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 143 */
+            {   int m4 = z->l - z->c; (void)m4; /* try, line 143 */
                 z->ket = z->c; /* [, line 143 */
-                if (!(eq_s_b(z, 2, s_18))) { z->c = z->l - m_keep; goto lab3; }
+                if (!(eq_s_b(z, 2, s_16))) { z->c = z->l - m4; goto lab3; } /* literal, line 143 */
                 z->bra = z->c; /* ], line 143 */
-                {   int ret = r_R2(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab3; } /* call R2, line 143 */
+                {   int ret = r_R2(z); /* call R2, line 143 */
+                    if (ret == 0) { z->c = z->l - m4; goto lab3; }
                     if (ret < 0) return ret;
                 }
                 {   int ret = slice_del(z); /* delete, line 143 */
                     if (ret < 0) return ret;
                 }
                 z->ket = z->c; /* [, line 143 */
-                if (!(eq_s_b(z, 2, s_19))) { z->c = z->l - m_keep; goto lab3; }
+                if (!(eq_s_b(z, 2, s_17))) { z->c = z->l - m4; goto lab3; } /* literal, line 143 */
                 z->bra = z->c; /* ], line 143 */
-                {   int ret = r_R2(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab3; } /* call R2, line 143 */
+                {   int ret = r_R2(z); /* call R2, line 143 */
+                    if (ret == 0) { z->c = z->l - m4; goto lab3; }
                     if (ret < 0) return ret;
                 }
                 {   int ret = slice_del(z); /* delete, line 143 */
@@ -926,48 +903,40 @@ static int r_standard_suffix(struct SN_env * z) {
     return 1;
 }
 
-static int r_verb_suffix(struct SN_env * z) {
-    int among_var;
-    {   int mlimit; /* setlimit, line 148 */
-        int m1 = z->l - z->c; (void)m1;
+static int r_verb_suffix(struct SN_env * z) { /* backwardmode */
+
+    {   int mlimit1; /* setlimit, line 148 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 148 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
+        mlimit1 = z->lb; z->lb = z->I[0];
         z->ket = z->c; /* [, line 149 */
-        among_var = find_among_b(z, a_7, 87); /* substring, line 149 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
+        if (!(find_among_b(z, a_7, 87))) { z->lb = mlimit1; return 0; } /* substring, line 149 */
         z->bra = z->c; /* ], line 149 */
-        switch(among_var) {
-            case 0: { z->lb = mlimit; return 0; }
-            case 1:
-                {   int ret = slice_del(z); /* delete, line 163 */
-                    if (ret < 0) return ret;
-                }
-                break;
+        {   int ret = slice_del(z); /* delete, line 163 */
+            if (ret < 0) return ret;
         }
-        z->lb = mlimit;
+        z->lb = mlimit1;
     }
     return 1;
 }
 
-static int r_vowel_suffix(struct SN_env * z) {
-    {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 171 */
+static int r_vowel_suffix(struct SN_env * z) { /* backwardmode */
+    {   int m1 = z->l - z->c; (void)m1; /* try, line 171 */
         z->ket = z->c; /* [, line 172 */
-        if (in_grouping_b(z, g_AEIO, 97, 242, 0)) { z->c = z->l - m_keep; goto lab0; }
+        if (in_grouping_b(z, g_AEIO, 97, 242, 0)) { z->c = z->l - m1; goto lab0; } /* grouping AEIO, line 172 */
         z->bra = z->c; /* ], line 172 */
-        {   int ret = r_RV(z);
-            if (ret == 0) { z->c = z->l - m_keep; goto lab0; } /* call RV, line 172 */
+        {   int ret = r_RV(z); /* call RV, line 172 */
+            if (ret == 0) { z->c = z->l - m1; goto lab0; }
             if (ret < 0) return ret;
         }
         {   int ret = slice_del(z); /* delete, line 172 */
             if (ret < 0) return ret;
         }
         z->ket = z->c; /* [, line 173 */
-        if (!(eq_s_b(z, 1, s_20))) { z->c = z->l - m_keep; goto lab0; }
+        if (z->c <= z->lb || z->p[z->c - 1] != 'i') { z->c = z->l - m1; goto lab0; } /* literal, line 173 */
+        z->c--;
         z->bra = z->c; /* ], line 173 */
-        {   int ret = r_RV(z);
-            if (ret == 0) { z->c = z->l - m_keep; goto lab0; } /* call RV, line 173 */
+        {   int ret = r_RV(z); /* call RV, line 173 */
+            if (ret == 0) { z->c = z->l - m1; goto lab0; }
             if (ret < 0) return ret;
         }
         {   int ret = slice_del(z); /* delete, line 173 */
@@ -976,13 +945,14 @@ static int r_vowel_suffix(struct SN_env * z) {
     lab0:
         ;
     }
-    {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 175 */
+    {   int m2 = z->l - z->c; (void)m2; /* try, line 175 */
         z->ket = z->c; /* [, line 176 */
-        if (!(eq_s_b(z, 1, s_21))) { z->c = z->l - m_keep; goto lab1; }
+        if (z->c <= z->lb || z->p[z->c - 1] != 'h') { z->c = z->l - m2; goto lab1; } /* literal, line 176 */
+        z->c--;
         z->bra = z->c; /* ], line 176 */
-        if (in_grouping_b(z, g_CG, 99, 103, 0)) { z->c = z->l - m_keep; goto lab1; }
-        {   int ret = r_RV(z);
-            if (ret == 0) { z->c = z->l - m_keep; goto lab1; } /* call RV, line 176 */
+        if (in_grouping_b(z, g_CG, 99, 103, 0)) { z->c = z->l - m2; goto lab1; } /* grouping CG, line 176 */
+        {   int ret = r_RV(z); /* call RV, line 176 */
+            if (ret == 0) { z->c = z->l - m2; goto lab1; }
             if (ret < 0) return ret;
         }
         {   int ret = slice_del(z); /* delete, line 176 */
@@ -994,67 +964,65 @@ static int r_vowel_suffix(struct SN_env * z) {
     return 1;
 }
 
-extern int italian_ISO_8859_1_stem(struct SN_env * z) {
+extern int italian_ISO_8859_1_stem(struct SN_env * z) { /* forwardmode */
     {   int c1 = z->c; /* do, line 182 */
-        {   int ret = r_prelude(z);
-            if (ret == 0) goto lab0; /* call prelude, line 182 */
+        {   int ret = r_prelude(z); /* call prelude, line 182 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
         z->c = c1;
     }
-    {   int c2 = z->c; /* do, line 183 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab1; /* call mark_regions, line 183 */
-            if (ret < 0) return ret;
-        }
-    lab1:
-        z->c = c2;
+    /* do, line 183 */
+    {   int ret = r_mark_regions(z); /* call mark_regions, line 183 */
+        if (ret == 0) goto lab1;
+        if (ret < 0) return ret;
     }
+lab1:
     z->lb = z->c; z->c = z->l; /* backwards, line 184 */
 
-    {   int m3 = z->l - z->c; (void)m3; /* do, line 185 */
-        {   int ret = r_attached_pronoun(z);
-            if (ret == 0) goto lab2; /* call attached_pronoun, line 185 */
+    {   int m2 = z->l - z->c; (void)m2; /* do, line 185 */
+        {   int ret = r_attached_pronoun(z); /* call attached_pronoun, line 185 */
+            if (ret == 0) goto lab2;
             if (ret < 0) return ret;
         }
     lab2:
-        z->c = z->l - m3;
+        z->c = z->l - m2;
     }
-    {   int m4 = z->l - z->c; (void)m4; /* do, line 186 */
-        {   int m5 = z->l - z->c; (void)m5; /* or, line 186 */
-            {   int ret = r_standard_suffix(z);
-                if (ret == 0) goto lab5; /* call standard_suffix, line 186 */
+    {   int m3 = z->l - z->c; (void)m3; /* do, line 186 */
+        {   int m4 = z->l - z->c; (void)m4; /* or, line 186 */
+            {   int ret = r_standard_suffix(z); /* call standard_suffix, line 186 */
+                if (ret == 0) goto lab5;
                 if (ret < 0) return ret;
             }
             goto lab4;
         lab5:
-            z->c = z->l - m5;
-            {   int ret = r_verb_suffix(z);
-                if (ret == 0) goto lab3; /* call verb_suffix, line 186 */
+            z->c = z->l - m4;
+            {   int ret = r_verb_suffix(z); /* call verb_suffix, line 186 */
+                if (ret == 0) goto lab3;
                 if (ret < 0) return ret;
             }
         }
     lab4:
     lab3:
-        z->c = z->l - m4;
+        z->c = z->l - m3;
     }
-    {   int m6 = z->l - z->c; (void)m6; /* do, line 187 */
-        {   int ret = r_vowel_suffix(z);
-            if (ret == 0) goto lab6; /* call vowel_suffix, line 187 */
+    {   int m5 = z->l - z->c; (void)m5; /* do, line 187 */
+        {   int ret = r_vowel_suffix(z); /* call vowel_suffix, line 187 */
+            if (ret == 0) goto lab6;
             if (ret < 0) return ret;
         }
     lab6:
-        z->c = z->l - m6;
+        z->c = z->l - m5;
     }
     z->c = z->lb;
-    {   int c7 = z->c; /* do, line 189 */
-        {   int ret = r_postlude(z);
-            if (ret == 0) goto lab7; /* call postlude, line 189 */
+    {   int c6 = z->c; /* do, line 189 */
+        {   int ret = r_postlude(z); /* call postlude, line 189 */
+            if (ret == 0) goto lab7;
             if (ret < 0) return ret;
         }
     lab7:
-        z->c = c7;
+        z->c = c6;
     }
     return 1;
 }
